<template>
  <nav class="navbar" data-testid="navbar">
    <div class="navbar-left">
      <div v-if="menuEnabled">
        <button
          aria-label="Open Menu"
          :aria-expanded="showMenu"
          aria-controls="nav-offcanvas"
          data-testid="button"
          @click="showMenu = true"
        >
          <sa-icon icon="menu" size="3" />
        </button>
      </div>
      <transition name="slideover">
        <div
          v-show="showMenu"
          id="nav-offcanvas"
          class="offcanvas"
          @click="showMenu = false"
        >
          <div class="content">
            <!-- @slot Left navigation menu -->
            <slot name="offcanvas"></slot>
          </div>
          <div class="footer">
            <!-- @slot Footer for left navigation menu -->
            <slot name="offcanvasFooter"></slot>
          </div>
        </div>
      </transition>
      <h1>
        <span class="app">
          <template v-if="$slots.appTitle">
            <!-- @slot Name of app. Can also be supplied in `appTitle` prop. -->
            <slot name="appTitle" data-testid="appTitle"></slot>
          </template>
          <template v-else>{{ appTitle }}</template>
        </span>
        <span v-if="pageTitle" class="page">{{ pageTitle }}</span>
      </h1>
    </div>
    <div class="navbar-right">
      <!-- @slot Right side of nav bar -->
      <slot name="right"></slot>
    </div>
    <div
      v-if="showMenu"
      class="background-fill"
      @click="showMenu = false"
    ></div>
  </nav>
</template>

<script>
export default {
  name: 'SaNavbar',
  props: {
    /** Name of app. Can also be supplied in `appTitle` slot. */
    appTitle: {
      type: String,
      default: 'App Title'
    },
    /** Name of this page/screen */
    pageTitle: {
      type: String,
      default: 'Page Title'
    },
    menuEnabled: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      showMenu: false
    }
  }
}
</script>

<style lang="scss" scoped>
.slideover-enter-active,
.slideover-leave-active {
  transition: $transition;
}
.slideover-enter,
.slideover-leave-to {
  transform: translate(-100%, 0);
}
.navbar {
  padding-top: spacing(2);
  padding-bottom: spacing(2);
  ::v-deep ul,
  ol {
    list-style: none;
  }
  .navbar-left {
    button {
      margin-right: 0.25rem;
      padding: 0 0.25rem;
      color: color(primary);
    }
    &,
    h1 {
      font-size: font-size(3);
      .page {
        margin-left: spacing(1);
        font-weight: $font-weight-regular;
      }
    }
  }
}
.offcanvas {
  position: fixed;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  top: 0;
  left: 0;
  width: 15rem;
  height: 100vh;
  margin: 0;
  padding: spacing(3) 0;
  border-right: 1px solid color(primary);
  color: color(white);
  background: color(primary);
  z-index: 100;
  box-shadow: $box-shadow;
  .content {
    overflow-y: auto;
    padding: 0 spacing(3);
  }
  .footer {
    padding: 0 spacing(3);
    margin-top: spacing(3);
    font-size: font-size(1);
  }
}
.background-fill {
  position: fixed;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
}
</style>
